(*
    ===========================================================================
    AboutBox
    ---------------------------------------------------------------------------
    2005/06/17  C
    2006/01/02  x̕ 2005 => 2006 ɂ
    2006.03.10  AppMessageBox / SelectDirectoryEx ǉ
    2006.03.11  IniFileɂR|[lgvpeBۑ/Čǉ
                (useŝł悭g֐u...)
    2006.09.05  vO̐ǉ
    2006.09.06  𖳑ʂɒǉ
    2007.06.26  t@CTCYEOóEpEőOʒǉ
    2007.09.06  t@Cǉ
    2007.09.08  TimeStampǉ
    2008.01.03  S~Ɏ̂Ăǉ
                t@C폜(FindFile.pas ɒǉ)
    2008.01.31  JƁu肪Ƃv\[Xt@C擾悤ɂ
    2008.06.16  S~ۂɒǉ
    2009.08.10  S~TCYǉ
    ===========================================================================
*)
unit Info;

interface

uses
    Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
    Buttons, ExtCtrls, StdCtrls, Dialogs;

type
  TInfoForm = class(TForm)
    PnlBack: TPanel;
    AppIcon: TImage;
    LblExeName: TLabel;
    LblEnvironment: TLabel;
    LblOsVersion: TLabel;
    LblPhys: TLabel;
    LblExeVersion: TLabel;
    lblURL: TLabel;
    lblMail: TLabel;
    LblLaunchOnStartup: TLabel;
    LblOpenStartup: TLabel;
    LblLaunchOnDesktop: TLabel;
    LblOpenFolderIn: TLabel;
    LblLaunchOnSendTo: TLabel;
    LblOpenSendTo: TLabel;
    Label1: TLabel;
    LblFileDescription: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    LblPageFile: TLabel;
    LblVirtual: TLabel;
    LblWorkingSetSize: TLabel;
    LblPageFaultCount: TLabel;
    LblPagefileUsage: TLabel;
    LblPagedPoolUsage: TLabel;
    LblNonPagedPoolUsage: TLabel;
    Timer1: TTimer;
    LblProcessTime: TLabel;
    LblThanks: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure lblURLClick(Sender: TObject);
    procedure lblMailClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormPaint(Sender: TObject);
    procedure LblExeNameClick(Sender: TObject);
    procedure LblLaunchOnStartupClick(Sender: TObject);
    procedure LblOpenStartupClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure UpdateStatus();
    procedure Timer1Timer(Sender: TObject);
  private
    procedure WMEraseBkGnd(var Msg: TWMEraseBkgnd); message WM_ERASEBKGND;
  public

  end;

//-----------------------------------------------------------------------------
//  ݔTCY
function RecycleBinSize(const ADriveRoot: String = 'C:\'): Int64;
//  ݔ
function RecycleBinIsEmpty(const ADriveRoot: String = 'C:\'): Boolean;
procedure EmptyRecycleBin(const ASilent: Boolean);
//  ݔs
procedure SendToRecycleBin(FileName: String);

//-----------------------------------------------------------------------------
//  t@CTCY擾(FileSize)
function FileSizeByFileSize(const FileName: string): Int64;

//-----------------------------------------------------------------------------
//  Oo
procedure PutLog(const APath, AText: String; const AMaxSize: Int64 = $FFFFFF);
//  ^CX^v
function TimeStamp(const AText: String; const AFormat: String = 'mm/dd hh:nn:ss'): String;

//------------------------------------------------------------------------------
//  p
function Quote(const AText: String): String;

//------------------------------------------------------------------------------
//  őOʂɎĂ
procedure BringWindowToFront(const AHandle: HWND);

//------------------------------------------------------------------------------
//  bZ[W{bNX
function AppMessageBox(const Msg: string; const Flag: integer): integer;

//------------------------------------------------------------------------------
//  G[bZ[W쐬
function BuildErrorMessage(const E: Exception = nil;
                            const AOption: String = ''): String;

//  t@C̃vpeB_CAOJ
procedure OpenFilePropertyDialog(const FileName: string);

//------------------------------------------------------------------------------
//  tH_I
function SelectDirectoryEx(Owner: TForm; const Caption: string;
                const Root: string; var Directory: string): Boolean;

//------------------------------------------------------------------------------
//  tH[̃LvVZbg
procedure SetFormCaption(Sender: TForm);

//  tH[ʒɈړ
procedure MoveToScreenCenter(Sender: TForm);

//------------------------------------------------------------------------------
//  ivpeBۑE
procedure SavePropertyToFile(const APath: String; AForm: TForm);

procedure LoadPropertyFromFile(const APath: String; AForm: TForm);

//------------------------------------------------------------------------------
//  ȈShellExecute
procedure SimpleShellExecute(const FileName: string; const Command: string = '');

//------------------------------------------------------------------------------
//  tH_̃pX
function GetSpecialFolderPath(const Folder: integer): string;
function GetDesktopFolderPath(): string;

//------------------------------------------------------------------------------
//  V[gJbg쐬
procedure CreateApplicationShortcut(const SrcPath, DstPath, ShortcutName: string);

//------------------------------------------------------------------------------
//  o[W\
procedure OpenInfoForm();

//------------------------------------------------------------------------------
//  \[Xɂo[W擾
const
    FVERREQ_Comments: String = 'Comments';
    FVERREQ_CompanyName: String = 'CompanyName';
    FVERREQ_FileDescription: String = 'FileDescription';
    FVERREQ_FileVersion: String = 'FileVersion';
    FVERREQ_InternalName: String = 'InternalName';
    FVERREQ_LegalCopyright: String = 'LegalCopyright';
    FVERREQ_LegalTrademarks: String = 'LegalTrademarks';
    FVERREQ_OriginalFilename: String = 'OriginalFilename';
    FVERREQ_PrivateBuild: String = 'PrivateBuild';
    FVERREQ_ProductName: String = 'ProductName';
    FVERREQ_ProductVersion: String = 'ProductVersion';
    FVERREQ_SpecialBuild: String = 'SpecialBuild';
    FVERREQ_DeveropEnvironment: String = 'DeveropEnvironment';
    FVERREQ_Thanks: String = 'Thanks';

// o[W擾
function GetVersionInfo(const Request, Path: string): string;

//  Windowso[W
function GetOsInfo(): string;


implementation

uses
    ShellAPi, ShlObj, ActiveX, ComObj, IniFiles, PsApi, DateUtils;

{$R *.dfm}

//=============================================================================
//  [eBeB֐
//=============================================================================

//-----------------------------------------------------------------------------
//  ݔɂȂɂĂ邩(S~̃ACet@CTCY)
//  Subject: [Delphi:52733] Sellapi ɂ
type
    PSHQUERYRBINFO = ^TSHQUERYRBINFO;
    TSHQUERYRBINFO = packed record
        cbSize: DWORD;
        i64Size:  Int64;
        i64NumItems: Int64;
    end;

function SHQueryRecycleBin(pszRootPath: PChar;
  pSHQueryRBInfo:PSHQUERYRBINFO): Integer; stdcall;
    external 'Shell32.dll' name 'SHQueryRecycleBinA';

function RecycleBinSize(const ADriveRoot: String = 'C:\'): Int64;
var
    LSHQUERYRBINFO: TSHQUERYRBINFO;
begin
    FillChar(LSHQUERYRBINFO, SizeOf(LSHQUERYRBINFO), 0);
    LSHQUERYRBINFO.cbSize := SizeOf(LSHQUERYRBINFO);
    if (SHQueryRecycleBin(PChar(ADriveRoot), @LSHQUERYRBINFO) = S_OK) then
    begin
        Result := LSHQUERYRBINFO.i64Size;
    end
    else
    begin
        Result := -1;
    end;
end;

function RecycleBinIsEmpty(const ADriveRoot: String = 'C:\'): Boolean;
begin
    Result := (RecycleBinSize(ADriveRoot) = 0);
end;

//-----------------------------------------------------------------------------
//  ݔ
//  Subject: [Delphi:50946] ݔɂ@ɂ
function SHEmptyRecycleBin(Handle: HWND; pszRootPath: PChar;
  dwFlags: DWORD): Integer; stdcall;
  external 'Shell32.dll' name 'SHEmptyRecycleBinA';

procedure EmptyRecycleBin(const ASilent: Boolean);
begin
    SHEmptyRecycleBin(HWND(nil), PChar(nil), Integer(ASilent));
end;

//-----------------------------------------------------------------------------
//  ݔs
//  http://www2.big.or.jp/~osamu/Delphi/Tips/key.cgi?key=2#0275.txt
procedure SendToRecycleBin(FileName: String);
var
    SHF: TSHFileOpStruct;
begin
    FillChar(SHF, SizeOf(SHF), 0);
    with SHF do
    begin
        Wnd    := Application.Handle;
        wFunc  := FO_DELETE;
        pFrom  := PChar(FileName + #0);
        fFlags := FOF_ALLOWUNDO;
    end;
    SHFileOperation(SHF);
end;

//-----------------------------------------------------------------------------
//  t@CTCY擾(FileSize)
function FileSizeByFileSize(const FileName: string): Int64;
var
    F: file;                            //  ^Ȃt@C
begin
    Result := -1;
    try
        AssignFile(F, FileName);
        try
            Reset(F, 1);                //  oCgt@C
            Result := FileSize(F);
        finally
            CloseFile(F);
        end;
    except
    end;
end;

//-----------------------------------------------------------------------------
//  Oo
procedure PutLog(const APath, AText: String; const AMaxSize: Int64 = $FFFFFF);
var
    F: TextFile;
    LSize: Int64;
    LBack: String;
begin
    if (AText = '') then Exit;
    AssignFile(F, APath);
    try
        if FileExists(APath) then
        begin
            LSize := FileSizeByFileSize(APath);
            if (LSize > AMaxSize) then
            begin
                LBack := ChangeFileExt(APath, '.bak');
                SetFileAttributes(
                    PChar(LBack),
                    GetFileAttributes(PChar(LBack)) and (not SysUtils.faReadOnly));
                DeleteFile(LBack);
                MoveFile(PChar(APath), PChar(LBack));
                Rewrite(F);
            end
            else
            begin
                Append(F);
            end;
        end
        else
        begin
            Rewrite(F);
        end;
        Writeln(f, AText);
        Flush(F);
    finally
        CloseFile(F);
    end;
end;

//-----------------------------------------------------------------------------
//  ^CX^v
function TimeStamp(const AText: String; const AFormat: String = 'mm/dd hh:nn:ss'): String;
begin
    Result := FormatDateTime(AFormat, Now()) + ' ' + AText;
end;

//-----------------------------------------------------------------------------
//  p
function Quote(const AText: String): String;
begin
    if (AText = '') then
    begin
        Result := '';
    end
    else
    begin
        Result := AnsiQuotedStr(AText, '"');
    end;
end;

//-----------------------------------------------------------------------------
//  őOʂɎĂ
//  Subject: [Delphi:80703] Re: OɃANeBuEBhEɂ
procedure BringWindowToFront(const AHandle: HWND);
var
    LOldID: Cardinal;
    LNewID: Cardinal;
begin
    LOldID := GetWindowThreadProcessID(GetForegroundWindow(), nil);
    LNewID := GetWindowThreadProcessID(AHandle, nil);
    AttachThreadInput(LOldID, LNewID, True);
    SetForegroundWindow(AHandle);
    AttachThreadInput(LOldID, LNewID, False);
end;

//------------------------------------------------------------------------------
//  Application.MessageBox
function AppMessageBox(const Msg: string; const Flag: integer): integer;
begin
    Application.BringToFront();
    Result := Application.MessageBox(PChar(Msg), PChar(Application.Title), Flag or MB_TOPMOST);
end;

//------------------------------------------------------------------------------
//  G[bZ[W쐬
function BuildErrorMessage(const E: Exception = nil;
                            const AOption: String = ''): String;
var
    LCode: Cardinal;
begin
    LCode := GetLastError();
    if (Assigned(E)) then
    begin
        Result := Format('[%d] [%s] %s %s', [LCode, E.ClassName(), E.Message, AOption]);
    end
    else
    begin
        Result := Format('[%d] %s %s', [LCode, SysErrorMessage(LCode), AOption]);
    end;
end;

//------------------------------------------------------------------------------
//  http://forum.nifty.com/fdelphi/samples/01269.html
//  [2004/04/08]ǔSelectDirectory@\_E
function BrowseFolderProc(hWindow: HWND; uMsg: UINT; lParam: LPARAM;
                                            lpData: LPARAM): Integer; stdcall;
var
    PathName: array[0..MAX_PATH] of Char;
begin
    case uMsg of
    BFFM_INITIALIZED:
        begin
            SendMessage(hWindow, BFFM_SETSELECTION, WPARAM(True), lpData);
        end;
    BFFM_SELCHANGED:
        begin
            SHGetPathFromIDList(PItemIDList(lParam), @PathName);
            SendMessage(hWindow, BFFM_SETSTATUSTEXT, 0, LongInt(PChar(@PathName)));
        end;
    end;
    Result := 0;
end;

//------------------------------------------------------------------------------
function SelectDirectoryEx(Owner: TForm; const Caption: string;
                const Root: string; var Directory: string): Boolean;
var
    IDList: PItemIDList;
    BI: TBrowseInfo;
    Malloc:IMalloc;
    WindowList: Pointer;
    Buffer: PChar;
begin
    Result := False;
    Directory := '';
    FillChar(BI, SizeOf(BI), 0);
    if (ShGetMalloc(Malloc) = S_OK) and (Malloc <> nil) then
    begin
        Buffer := Malloc.Alloc(MAX_PATH);
        try
            BI.hwndOwner      := Owner.Handle;
            BI.pidlRoot       := nil;
            BI.pszDisplayName := Buffer;
            BI.lpszTitle      := PChar(Caption);
            BI.ulFlags        := BIF_STATUSTEXT or BIF_RETURNONLYFSDIRS;
            BI.lpfn           := @BrowseFolderProc;
            BI.lParam         := integer(PChar(Root));

            WindowList := DisableTaskWindows(0);
            try
                IDList := ShBrowseForFolder(BI);
            finally
                EnableTaskWindows(WindowList);
            end;

            Result := (IDList <> nil);
            if Result then
            begin
                ShGetPathFromIDList(IDList, Buffer);
                Malloc.Free(IDList);
                Directory := Buffer;
            end;
        finally
            Malloc.Free(Buffer);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  ShellExecutebp[
procedure SimpleShellExecute(const FileName: string; const Command: string = '');
begin
    try
        ShellExecute(Application.MainForm.Handle,
                     nil,
                     PChar(FileName),
                     PChar(Command),
                     PChar(ExtractFilePath(FileName)),
                     SW_SHOW);
    except
        ;
    end;
end;

//-----------------------------------------------------------------------------
//  t@C̃vpeB_CAO\
//  http://homepage1.nifty.com/MADIA/delphi/Win32API/Properties.htm
//  ms-help://MS.PSDK.1033/shellcc/platform/shell/reference/structures/shellexecuteinfo.htm
procedure OpenFilePropertyDialog(const FileName: string);
var
    SH: TSHELLEXECUTEINFO;
    Mask: Cardinal;
begin
    //  
    FillChar(SH, SizeOf(SH), 0);
    Mask := SEE_MASK_NOCLOSEPROCESS or SEE_MASK_INVOKEIDLIST or SEE_MASK_FLAG_NO_UI;
    //  ݒ
    SH.cbSize       := Sizeof(SH);
    SH.fMask        := Mask;
    SH.Wnd          := Application.MainForm.Handle;
    SH.lpVerb       := 'properties';
    SH.lpParameters := nil;
    SH.lpDirectory  := nil;
    SH.lpIDList     := nil;
    SH.lpFile := PChar(FileName);
    //  s
    ShellExecuteEx(@SH);
end;

//=============================================================================
//  tH[[eBeB֐
//=============================================================================

//-----------------------------------------------------------------------------
//  tH[̃LvV
procedure SetFormCaption(Sender: TForm);
var
    AppVer: string;
begin
    AppVer := Format('Ver.%s', [GetVersionInfo(FVERREQ_FileVersion, ParamStr(0))]);

    //  LvVݒ
    Sender.Caption := Application.Title + ' ' + AppVer + ' - ' + Sender.Name;
end;

//-----------------------------------------------------------------------------
//  ʂ̐^Ɉړ
procedure MoveToScreenCenter(Sender: TForm);
var
    R: TRect;
begin
    SystemParametersInfo(SPI_GETWORKAREA, 0, @R, 0);
    Sender.Left := (R.Right - R.Left - Sender.Width) div 2;
    Sender.Top := (R.Bottom - R.Top - Sender.Height) div 2;
end;

//-----------------------------------------------------------------------------
//  ivpeBۑ
procedure SavePropertyToFile(const APath: String; AForm: TForm);
var
    LIniFile: TIniFile;

    procedure WriteInteger(const ASection, AIdent: String; const AValue: Integer);
    begin
        LIniFile.WriteInteger(AForm.Name + '.' +  ASection, AIdent, AValue);
    end;
    procedure WriteString(const ASection, AIdent: String; const AValue: String);
    begin
        LIniFile.WriteString(AForm.Name + '.' +  ASection, AIdent, AValue);
    end;
    procedure WriteBool(const ASection, AIdent: String; const AValue: Boolean);
    begin
        LIniFile.WriteBool(AForm.Name + '.' +  ASection, AIdent, AValue);
    end;

var
    i: integer;
    LComp: TComponent;
begin

    LIniFile := nil;
    try
        LIniFile := TIniFile.Create(APath);

        WriteInteger(AForm.Name, 'Top', AForm.Top);
        WriteInteger(AForm.Name, 'Left', AForm.Left);
        WriteInteger(AForm.Name, 'Width', AForm.Width);
        WriteInteger(AForm.Name, 'Height', AForm.Height);

        // tH[ɏĂR|[lgقڑS
        for i := 0 to AForm.ComponentCount - 1 do
        begin
            LComp := AForm.Components[i];

            with LComp do WriteInteger(Name, 'Tag', Tag);

            if (LComp.InheritsFrom(TControl)) then
            begin
                with TControl(LComp) do WriteBool(Name, 'Enabled', Enabled);
            end;

            if (LComp.InheritsFrom(TEdit)) then
            begin
                with TEdit(LComp) do WriteString(Name, 'Text', Text);
            end
            else if (LComp.InheritsFrom(TCheckBox)) then
            begin
                with TCheckBox(LComp) do WriteBool(Name, 'Checked', Checked);
            end
            else if (LComp.InheritsFrom(TRadioButton)) then
            begin
                with TRadioButton(LComp) do WriteBool(Name, 'Checked', Checked);
            end;

            if (LComp.InheritsFrom(TOpenDialog)) then
            begin
                with TOpenDialog(LComp) do WriteString(Name, 'InitialDir', InitialDir);
            end;
        end;
    finally
        LIniFile.Free();
    end;
end;

//-----------------------------------------------------------------------------
//  ivpeB
procedure LoadPropertyFromFile(const APath: String; AForm: TForm);
var
    LIniFile: TIniFile;

    function ReadInteger(const ASection, AIdent: String; const ADefault: Integer = 0): Integer;
    begin
        Result := LIniFile.ReadInteger(AForm.Name + '.' +  ASection, AIdent, ADefault);
    end;
    function ReadString(const ASection, AIdent: String; const ADefault: String = ''): String;
    begin
        Result := LIniFile.ReadString(AForm.Name + '.' +  ASection, AIdent, ADefault);
    end;
    function ReadBool(const ASection, AIdent: String; const ADefault: Boolean = False): Boolean;
    begin
        Result := LIniFile.ReadBool(AForm.Name + '.' +  ASection, AIdent, ADefault);
    end;

var
    i: integer;
    LComp: TComponent;
begin

    LIniFile := nil;
    try
        LIniFile := TIniFile.Create(APath);

        AForm.Top := ReadInteger(AForm.Name, 'Top', AForm.Top);
        AForm.Left := ReadInteger(AForm.Name, 'Left', AForm.Left);
        AForm.Width := ReadInteger(AForm.Name, 'Width', AForm.Width);
        AForm.Height := ReadInteger(AForm.Name, 'Height', AForm.Height);

        // tH[ɏĂR|[lgقڑS
        for i := 0 to AForm.ComponentCount - 1 do
        begin
            LComp := AForm.Components[i];

            with LComp do Tag := ReadInteger(Name, 'Tag', Tag);

            if (LComp.InheritsFrom(TControl)) then
            begin
                with TControl(LComp) do Enabled := ReadBool(Name, 'Enabled', Enabled);
            end;

            if (LComp.InheritsFrom(TEdit)) then
            begin
                with TEdit(LComp) do Text := ReadString(Name, 'Text', Text);
            end
            else if (LComp.InheritsFrom(TCheckBox)) then
            begin
                with TCheckBox(LComp) do Checked := ReadBool(Name, 'Checked', Checked);
            end
            else if (LComp.InheritsFrom(TRadioButton)) then
            begin
                with TRadioButton(LComp) do Checked := ReadBool(Name, 'Checked', Checked);
            end;

            if (LComp.InheritsFrom(TOpenDialog)) then
            begin
                with TOpenDialog(LComp) do InitialDir := ReadString(Name, 'InitialDir', InitialDir);
            end;
        end;
    finally
        LIniFile.Free();
    end;
end;

//-----------------------------------------------------------------------------
//  OS̃o[W
type
    TOSVersionInfoEx = record
        dwOSVersionInfoSize : DWORD;
        dwMajorVersion      : DWORD;
        dwMinorVersion      : DWORD;
        dwBuildNumber       : DWORD;
        dwPlatformId        : DWORD;
        szCSDVersion        : array[0..127] of AnsiChar;
        wServicePackMajor   : WORD;
        wServicePackMinor   : WORD;
        wSuiteMask          : WORD;
        wProductType        : BYTE;
        wReserved           : BYTE;
    end;

// Windows.pas
function GetVersionEx(var lpVersionInformation: TOSVersionInfoEx): BOOL; stdcall; external kernel32 name 'GetVersionExA';

// http://www.geocities.jp/ht_deko/ft0203.html
// http://plaza5.mbn.or.jp/~heropa/vb25.htm
const
    VER_NT_WORKSTATION       = 1;
    VER_NT_DOMAIN_CONTROLLER = 2;
    VER_NT_SERVER            = 3;
    VER_SUITE_SMALLBUSINESS            = $0001;
    VER_SUITE_ENTERPRISE               = $0002;
    VER_SUITE_BACKOFFICE               = $0004;
    VER_SUITE_TERMINAL                 = $0010;
    VER_SUITE_SMALLBUSINESS_RESTRICTED = $0020;
    VER_SUITE_DATACENTER               = $0080;
    VER_SUITE_PERSONAL                 = $0200;
    VER_SUITE_BLADE                    = $0400;


//  蔲Ńo[W擾
function    GetOsInfoEasy(): string;

    function	PlatformId(ID: Cardinal): string;
    begin
        case ID of
            VER_PLATFORM_WIN32s			: Result := 'Windows 3.1';
            VER_PLATFORM_WIN32_WINDOWS	: Result := 'Windows 95';
            VER_PLATFORM_WIN32_NT		: Result := 'Windows NT';
        end;
    end;

var
    osi: TOSVersionInfo;
begin
    FillChar(osi, SizeOf(TOSVersionInfo), #0);
    osi.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
    Windows.GetVersionEx(osi);
    Result := Format('%s Version %d.%d (Build %d : %s)',
            [PlatformId(osi.dwPlatformId),
            osi.dwMajorVersion,
            osi.dwMinorVersion,
            osi.dwBuildNumber,
            osi.szCSDVersion
        ]);
end;

//  {CŃo[W擾
function    GetOsInfoHard(): string;
var
    osvi:TOSVersionInfoEx;
    res : Boolean;
    Key: HKEY;
    szProductType: string;
    dwBufLen, dwTemp: DWORD;
    lRet: integer;
begin
    Result := 'Unknown';

    // OSVERSIONINFOEX  GetVersionEx Ă݂ 
    // s OSVERSIONINFO łĂ݂ 

    // 
    FillChar(osvi, SizeOf(TOSVersionInfoEx), #0);

    // \̃TCYZbg
    osvi.dwOSVersionInfoSize := SizeOf(TOSVersionInfoEx);

    // Ă݂
    res := GetVersionEx(osvi);

    // s
    if not res then
    begin
        // ЂƂ̍\̂
        osvi.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
        // ߂Ȃ炠߂
        if not GetVersionEx(osvi) then Exit;
    end;

    // dwPlatformId ŌɂȂقǏꍇ킯
    case osvi.dwPlatformId of

    // Windows NT n.
    VER_PLATFORM_WIN32_NT:
        begin

            // Ɠ肵Ă݂
            if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 2) then
            begin
                Result := 'Microsoft Windows .NET Server 2003 family, ';
            end else
            if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 1) then
            begin
                Result := 'Microsoft Windows XP ';
            end else
            if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 0) then
            begin
                Result := 'Microsoft Windows 2000 ';
            end else
            begin
            if (osvi.dwMajorVersion <= 4) then
            begin
                Result := 'Microsoft Windows NT ';
            end else
                Result := 'Windows NT product family? ';
            end;

            // Windows NT 4.0 SP6 ȍ~Ɠ˂Œׂ.
            if res then
            begin

                // workstation ^Cv
                if (osvi.wProductType = VER_NT_WORKSTATION) then
                begin
                    if (osvi.dwMajorVersion = 4) then
                    begin
                        Result := Result + 'Workstation 4.0 ';
                    end else
                    if (osvi.wSuiteMask and VER_SUITE_PERSONAL) = VER_SUITE_PERSONAL then
                    begin
                        Result := Result + 'Home Edition ';
                    end else
                    begin
                        Result := Result + 'Professional ';
                    end;
                end else

                // server ^Cv
                if (osvi.wProductType = VER_NT_SERVER) then
                begin
                    if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 2) then
                    begin
                        if (osvi.wSuiteMask and VER_SUITE_DATACENTER) = VER_SUITE_DATACENTER then
                        begin
                            Result := Result + 'Datacenter Edition ';
                        end else
                        if (osvi.wSuiteMask and VER_SUITE_ENTERPRISE) = VER_SUITE_ENTERPRISE then
                        begin
                            Result := Result + 'Enterprise Edition ';
                        end else
                        if (osvi.wSuiteMask = VER_SUITE_BLADE) then
                        begin
                            Result := Result + 'Web Edition ';
                        end else
                        begin
                            Result := Result + 'Standard Edition ';
                        end;
                    end else
                    if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 0) then
                    begin
                        if (osvi.wSuiteMask and VER_SUITE_DATACENTER) = VER_SUITE_DATACENTER then
                        begin
                            Result := Result + 'Datacenter Server ';
                        end else
                        if (osvi.wSuiteMask and VER_SUITE_ENTERPRISE) = VER_SUITE_ENTERPRISE then
                        begin
                            Result := Result + 'Advanced Server ';
                        end else
                        begin
                            Result := Result + 'Server ';
                        end;
                    end else
                    // Windows NT 4.0
                    begin
                        if (osvi.wSuiteMask and VER_SUITE_ENTERPRISE) = VER_SUITE_ENTERPRISE then
                        begin
                            Result := Result + 'Server 4.0, Enterprise Edition ';
                        end else
                        begin
                            Result := Result + 'Server 4.0 ';
                        end;
                    end;
                end;

            end else
            // Windows NT 4.0 SP5 ȑÔ
            begin
                lRet := RegOpenKeyEx(
                            HKEY_LOCAL_MACHINE,
                            'SYSTEM\CurrentControlSet\Control\ProductOptions',
                            0,
                            KEY_QUERY_VALUE,
                            Key
                        );
                if lRet <> ERROR_SUCCESS then Exit;

                dwBufLen := 255;
                szProductType := '';
                SetLength(szProductType, dwBufLen);

                lRet := RegQueryValueEx(
                            Key,
                            'ProductType',
                            nil,
                            nil,
                            @szProductType[1],
                            @dwBufLen
                        );
                if (lRet <> ERROR_SUCCESS) then Exit;
                dwTemp := Length(szProductType);
                if (dwBufLen > dwTemp) then Exit;
                SetLength(szProductType, dwBufLen);

                RegCloseKey(Key);

                if UpperCase(szProductType) = 'WINNT' then
                begin
                    Result := Result + 'Workstation ';
                end else
                if UpperCase(szProductType) = 'LANMANNT' then
                begin
                    Result := Result + 'Server ';
                end else
                if UpperCase(szProductType) = 'SERVERNT' then
                begin
                    Result := Result + 'Advanced Server ';
                end;

                Result := Result + Format('%d.%d', [osvi.dwMajorVersion, osvi.dwMinorVersion]);
            end;

            // T[rXpbNƂrhԍƂ

            if (osvi.dwMajorVersion = 4) and (lstrcmpi( osvi.szCSDVersion, 'Service Pack 6' ) = 0 ) then
            begin
                // SP6 ? SP6a?

                lRet := RegOpenKeyEx(
                            HKEY_LOCAL_MACHINE,
                            'SOFTWARE\Microsoft\Windows NT\CurrentVersion\Hotfix\Q246009',
                            0,
                            KEY_QUERY_VALUE,
                            Key
                        );
                if (lRet = ERROR_SUCCESS) then
                begin
                    Result := Result + Format('Service Pack 6a (Build %d)', [osvi.dwBuildNumber and $FFFF]);
                end else

                // Windows NT 4.0 prior to SP6a
                begin
                    Result := Result + Format('%s (Build %d)', [osvi.szCSDVersion, osvi.dwBuildNumber and $FFFF]);
                end;
                RegCloseKey(Key);
            end else

            // Windows NT 3.51 and earlier or Windows 2000 and later
            begin
                Result := Result + Format('%s (Build %d)', [osvi.szCSDVersion, osvi.dwBuildNumber and $FFFF]);
            end;

        end;

    // Windows 95 n.
    VER_PLATFORM_WIN32_WINDOWS:
        begin
            // win95
            if (osvi.dwMajorVersion = 4) and (osvi.dwMinorVersion = 0) then
            begin
                Result := 'Microsoft Windows 95 ';
                if (osvi.szCSDVersion[1] = 'C') or (osvi.szCSDVersion[1] = 'B') then
                begin
                    Result := Result + 'OSR2 ';
                end;
            end else
            // win98
            if (osvi.dwMajorVersion = 4) and (osvi.dwMinorVersion = 10) then
            begin
                Result := 'Microsoft Windows 98 ';
                if ( osvi.szCSDVersion[1] = 'A') then
                begin
                    Result := Result + 'SE ';
                end;
            end else
            // winme
            if (osvi.dwMajorVersion = 4) and (osvi.dwMinorVersion = 90) then
            begin
                Result := 'Microsoft Windows Millennium Edition';
            end;
        end;

    // ȊO
    VER_PLATFORM_WIN32s:
        begin
            Result := 'Microsoft Win32s';
        end;

    end;

end;

//  Ăяop
function GetOsInfo(): string;
begin
    try
        Result := GetOsInfoHard();
    except
        try
            Result := GetOsInfoEasy();
        except
            Result := 'Microsoft Windows';
        end;
    end;
end;

//------------------------------------------------------------------------------
// o[W擾
//  http://www2.odn.ne.jp/~cag07740/tech_info/delphi_ans5.html
//  http://hp.vector.co.jp/authors/VA026252/tips/delphi_version.html
//  http://www2.big.or.jp/~osamu/Delphi/tips.cgi?index=0226.txt
function GetVersionInfo(const Request, Path: string): string;
const
    Translation = '\VarFileInfo\Translation';
    FileInfo = '\StringFileInfo\%0.4s%0.4s\';
var
    BufSize, HWnd: DWORD;
    VerInfoBuf: Pointer;
    VerData: Pointer;
    VerDataLen: Longword;
    PathLocale: String;
begin
    // Kvȃobt@̃TCY擾
    BufSize := GetFileVersionInfoSize(PChar(Path), HWnd);
    if BufSize <> 0 then
    begin
        // m
        GetMem(VerInfoBuf, BufSize);
        try
            GetFileVersionInfo(PChar(Path), 0, BufSize, VerInfoBuf);
            // ϐubN̕ϊe[uw
            VerQueryValue(VerInfoBuf, PChar(Translation), VerData, VerDataLen);
            if (VerDataLen > 0) then
            begin
                // 8̂PUiɕϊ
                // '\StringFileInfo\027382\FileDescription'
                PathLocale := Format(FileInfo + Request,
                                [IntToHex(Integer(VerData^) and $FFFF, 4),
                                IntToHex((Integer(VerData^) shr 16) and $FFFF, 4)]);
                VerQueryValue(VerInfoBuf, PChar(PathLocale), VerData, VerDataLen);
                if VerDataLen > 0 then
                begin
                    // VerData̓[ŏI镶ł͂ȂƂɒ
                    result := '';
                    SetLength(result, VerDataLen);
                    StrLCopy(PChar(result), VerData, VerDataLen);
                    Result := Trim(Result);
                end;
            end;
        finally
            // 
            FreeMem(VerInfoBuf);
        end;
    end;
end;

//=============================================================================
//  X^[gAbvtH_
//=============================================================================

//-----------------------------------------------------------------------------
//  tH_
//  http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#ishelllink
function GetSpecialFolderPath(const Folder: integer): string;
var
    pidlPath: PItemIDList;
    StartupPath: array[0..MAX_PATH] of Char;
begin
    SHGetSpecialFolderLocation(Application.Handle, Folder, pidlPath);
    SHGetPathFromIDList(pidlPath, StartupPath);
    Result := StartupPath;
end;

//-----------------------------------------------------------------------------
//  X^[gAbvtH_
function GetStartUpFolderPath(): string;
begin
    Result := GetSpecialFolderPath(CSIDL_STARTUP);
end;

//-----------------------------------------------------------------------------
//  tH_
function GetSendToFolderPath(): string;
begin
    Result := GetSpecialFolderPath(CSIDL_SENDTO);
end;

//-----------------------------------------------------------------------------
//  fXNgbv
function GetDesktopFolderPath(): string;
begin
    Result := GetSpecialFolderPath(CSIDL_DESKTOP);
end;

//-----------------------------------------------------------------------------
//  V[gJbgo^
//  http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#ishelllink
procedure CreateApplicationShortcut(const SrcPath, DstPath, ShortcutName: string);
var
    ShellLink: IShellLink;
    PersistFile: IPersistFile;
    FileName: String;
    LinkFileName: string;
    WFileName: WideString;
begin
    //  V[gJbg̐ݒ
    FileName := SrcPath;
    //  V[gJbgpCOMIuWFNg쐬
    ShellLink := CreateComObject(CLSID_ShellLink) as IShellLink;
    //  V[gJbgt@CpIuWFNg
    PersistFile:= ShellLink as IPersistFile;
    //  t@ČɎw肷p[^
    ShellLink.SetArguments('/starup');
    //  st@C̃tpX
    ShellLink.SetPath(PChar(FileName));
    //  ƃtH_
    ShellLink.SetWorkingDirectory(PChar(ExtractFileDir(FileName)));
    //  V[gJbgt@C̍쐬
    LinkFileName := Format('%s\%s.lnk',[ExcludeTrailingPathDelimiter(DstPath), ShortcutName]);
    WFileName := WideString(LinkFileName);
    //  t@C쐬
    OleCheck(PersistFile.Save(PWChar(WFileName), False));
end;

//-----------------------------------------------------------------------------
//  \
procedure OpenInfoForm();
var
    InfoForm: TInfoForm;
begin
    InfoForm := TInfoForm.Create(Application);
    try
        InfoForm.ShowModal();
    finally
        InfoForm.Free();
    end;
end;

//=============================================================================
//  tH[Cxgnh
//=============================================================================

//-----------------------------------------------------------------------------
procedure TInfoForm.WMEraseBkGnd(var Msg: TWMEraseBkgnd);
begin
    //
end;

//-----------------------------------------------------------------------------
//  tH[쐬
procedure TInfoForm.FormCreate(Sender: TObject);
begin
    SetFormCaption(Self);

    //  EXẼRg\
    LblFileDescription.Caption := GetVersionInfo(FVERREQ_FileDescription, ParamStr(0));

    //  EXE\
    lblExeName.Caption := ExtractFileName(ParamStr(0));

    //  ACR\
    AppIcon.Picture.Icon := Application.Icon;

    //  VXeEvZXXV
    UpdateStatus();

    //  OSo[W\
    LblOsVersion.Caption := StringReplace(GetOsInfo(), 'Microsoft ', '', []);

    //  EXEo[W\
    LblExeVersion.Caption := Format('Ver.%s', [GetVersionInfo(FVERREQ_FileVersion, ParamStr(0))]);

    //  J\
    LblEnvironment.Caption := GetVersionInfo(FVERREQ_DeveropEnvironment, ParamStr(0));

    //  肪Ƃ\
    LblThanks.Caption := GetVersionInfo(FVERREQ_Thanks, ParamStr(0));

    //  \eŃtH[TCY𒲐
    PnlBack.AutoSize := True;
    Self.AutoSize := True;

    //  ʂ̐^Ɉړ
    MoveToScreenCenter(Self);
end;

//-----------------------------------------------------------------------------
//  z[y[WN
procedure TInfoForm.lblURLClick(Sender: TObject);
begin
    SimpleShellExecute(lblURL.Caption);
end;

//-----------------------------------------------------------------------------
//  z[y[WN-2
procedure TInfoForm.Label1Click(Sender: TObject);
begin
    SimpleShellExecute(TLabel(Sender).Hint);
end;

//-----------------------------------------------------------------------------
//  [[N
procedure TInfoForm.lblMailClick(Sender: TObject);
begin
    SimpleShellExecute(Format('MailTo:%s?subject=from [%s] user', [
        lblMail.Caption, ExtractFileName(Application.ExeName)])
    );
end;

//-----------------------------------------------------------------------------
//  t@CvpeB_CAO\
procedure TInfoForm.LblExeNameClick(Sender: TObject);
begin
    OpenFilePropertyDialog(ParamStr(0));
end;

//-----------------------------------------------------------------------------
//  X^[gAbvfXNgbvɃV[gJbg
procedure TInfoForm.LblLaunchOnStartupClick(Sender: TObject);
begin
    if (Sender = LblLaunchOnStartup) then
        CreateApplicationShortcut(ParamStr(0), GetStartUpFolderPath(), ChangeFileExt(ExtractFileName(ParamStr(0)), ''))
    else if (Sender = LblLaunchOnDesktop) then
        CreateApplicationShortcut(ParamStr(0), GetDesktopFolderPath(), ChangeFileExt(ExtractFileName(ParamStr(0)), ''))
    else if (Sender = LblLaunchOnSendTo) then
        CreateApplicationShortcut(ParamStr(0), GetSendToFolderPath(), ChangeFileExt(ExtractFileName(ParamStr(0)), ''))
    ;
end;

//-----------------------------------------------------------------------------
//  X^[gAbvJ
procedure TInfoForm.LblOpenStartupClick(Sender: TObject);
begin
    if (Sender = LblOpenStartup) then
        SimpleShellExecute(GetStartUpFolderPath())
    else if (Sender = LblOpenFolderIn) then
        SimpleShellExecute(ExtractFilePath(ParamStr(0)))
    else if (Sender = LblOpenSendTo) then
        SimpleShellExecute(GetSendToFolderPath())
    ;
end;

//-----------------------------------------------------------------------------
//  ̃L[ꂽ
procedure TInfoForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    Self.Close();
end;

//-----------------------------------------------------------------------------
procedure TInfoForm.FormPaint(Sender: TObject);
var
    BkBrushColor: TColor;
begin
    BkBrushColor := Self.Canvas.Brush.Color;
    Self.Canvas.Brush.Color := clBlack;
    Self.Canvas.Rectangle(Self.BoundsRect);
    Self.Canvas.Brush.Color := BkBrushColor;
end;

//-----------------------------------------------------------------------------
//  \O
//  http://www.asahi-net.or.jp/~HA3T-NKMR/tips025.htm
procedure TInfoForm.FormShow(Sender: TObject);
begin
    // AvP[VEBhE^XNo[ɕ\̂h
    ShowWindow(Application.Handle, SW_HIDE);
end;

//-----------------------------------------------------------------------------
//  oCg𕶎\
//  http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#getmemory
type
    TDispType = (dtNone, dtByte, dtKilo, dtMega);

function B2S(const ByteSize: Int64; const DispType: TDispType = dtKilo): string;
var
    Check: double;
begin
    Check := ByteSize;

    case DispType of

    dtNone:
        begin
            Result := FormatFloat('#,##0', Check);
        end;

    dtByte:
        begin
            Result := FormatFloat('#,##0 B', Check);
        end;

    dtKilo:
        begin
            Check := Check / 1024;
            //Result := FormatFloat('#,##0.00 KB', Check);
            Result := FormatFloat('#,##0 KB', Check);
        end;

    else
        begin
            Check := (Check / 1024) / 1024;
            Result := FormatFloat('#,##0.00 MB', Check);
        end;

    end;
end;

//-----------------------------------------------------------------------------
//  b𕶎\
function SecondToText(const ASeconds: Integer): String;
var
    H, M, MM, S: Integer;
begin
    //  ubv
    S := ASeconds mod 60;

    //  uv
    MM := (ASeconds - S) div 60;

    //  uv
    M := MM mod 60;

    //  uv
    H := MM div 60;

    Result := Format('%d:%2.2d:%2.2d', [H, M, S])
end;

//-----------------------------------------------------------------------------
//  VXeEvZXXV(sȂƂ)
//  http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#getmemory
//  http://forum.nifty.com/fdelphi/samples/01380.html
//  http://community.borland.com/article/0,1410,16582,00.html
procedure TInfoForm.UpdateStatus();
var
    MS: TMemoryStatus;
    LHandle: THandle;
    PMC: TProcessMemoryCounters;
var
    TZI: TTimeZoneInformation;

    ftCreation: TFileTime;
    ftExitTime: TFileTime;
    ftKernelTime: TFileTime;
    ftUserTime: TFileTime;

    stCreation: TSystemTime;
    //stExitTime: TSystemTime;
    stKernelTime: TSystemTime;
    stUserTime: TSystemTime;

    dtCreation: TDateTime;
    //dtExitTime: TDateTime;
    dtKernelTime: TDateTime;
    dtUserTime: TDateTime;
begin
    //  𓾂
    FillChar(MS, SizeOf(MemoryStatus), 0);
    MS.dwLength := SizeOf(MS);
    GlobalMemoryStatus(MS);

    //  o
    LblPhys.Caption     := Format('Free Physical Memory:%s; Total:%s',
                                [B2S(MS.dwAvailPhys), B2S(MS.dwTotalPhys)]);
    LblPageFile.Caption := Format('Free Paging File:%s; Total:%s',
                                [B2S(MS.dwAvailPageFile), B2S(MS.dwTotalPageFile)]);
    LblVirtual.Caption  := Format('Free Virtual Memory:%s; Total:%s',
                                [B2S(MS.dwAvailVirtual), B2S(MS.dwTotalVirtual)]);

    //  vZXnh
    LHandle := GetCurrentProcess();

    //  𓾂
    FillChar(PMC, SizeOf(PMC), 0);
    PMC.cb := SizeOf(PMC);
    GetProcessMemoryInfo(LHandle, @PMC, SizeOf(PMC));

    //  gp
    LblWorkingSetSize.Caption := Format('Memory Usage:%s; Peak:%s',
                                 [B2S(PMC.WorkingSetSize), B2S(PMC.PeakWorkingSetSize)]);

    //  y[WtHg
    LblPageFaultCount.Caption := Format('Page Fault:%s', [B2S(PMC.PageFaultCount, dtNone)]);

    //  zTCY
    LblPagefileUsage.Caption  := Format('Pagefile Usage:%s; Peak:%s',
                                 [B2S(PMC.PagefileUsage), B2S(PMC.PeakPagefileUsage)]);

    //  y[Wv[
    LblPagedPoolUsage.Caption  := Format('Paged Pool Usage:%s; Peak:%s',
                                 [B2S(PMC.QuotaPagedPoolUsage), B2S(PMC.QuotaPeakPagedPoolUsage)]);

    //  y[Wv[
    LblNonPagedPoolUsage.Caption  := Format('NonPaged Pool Usage:%s; Peak:%s',
                                 [B2S(PMC.QuotaNonPagedPoolUsage), B2S(PMC.QuotaPeakNonPagedPoolUsage)]);

    //  ^C][擾
    FillChar(TZI, SizeOf(TZI), 0);
    GetTimeZoneInformation(TZI);

    //  vZXɊւ鎞ԏ擾
    GetProcessTimes(LHandle, ftCreation, ftExitTime, ftKernelTime, ftUserTime);

    //  VXeɕϊ
    FileTimeToSystemTime(ftCreation, stCreation);
    //FileTimeToSystemTime(ftExitTime, stExitTime);
    FileTimeToSystemTime(ftKernelTime, stKernelTime);
    FileTimeToSystemTime(ftUserTime, stUserTime);
    //  t^ɕϊ
    dtCreation := SystemTimeToDateTime(stCreation);
    //dtExitTime := SystemTimeToDateTime(stExitTime);
    dtKernelTime := SystemTimeToDateTime(stKernelTime);
    dtUserTime := SystemTimeToDateTime(stUserTime);

    //  -109205  ()Ԃ̍ŏl(midnight on January 1, 1601 at Greenwich, England)
    LblProcessTime.Caption := Format('Kernel:%s; User:%s; Process:%s',
                                [SecondToText(SecondsBetween(dtKernelTime, -109205)),
                                 SecondToText(SecondsBetween(dtUserTime, -109205)),
                                 SecondToText(SecondsBetween(dtCreation, IncMinute(Now(), TZI.Bias)))]);
end;


//-----------------------------------------------------------------------------
//  XV
procedure TInfoForm.Timer1Timer(Sender: TObject);
var
    LTimer: TTimer;
begin
    LTimer := TTimer(Sender);
    LTimer.Enabled := False;
    UpdateStatus();
    LTimer.Enabled := True;
end;

//-----------------------------------------------------------------------------
//  http://homepage1.nifty.com/MADIA/delphi/delphi_bbs/200308_03080004.html
initialization
    CoInitialize(nil);
finalization
    CoUninitialize();
end.
